import type { FormatOptions } from 'src/types';
import Tokenizer from './Tokenizer';
/** Main formatter class that produces a final output string from list of tokens */
export default class Formatter {
    private cfg;
    private params;
    constructor(cfg: FormatOptions);
    /**
     * SQL Tokenizer for this formatter, provided by subclasses.
     */
    protected tokenizer(): Tokenizer;
    /**
     * Formats an SQL query.
     * @param {string} query - The SQL query string to be formatted
     * @return {string} The formatter query
     */
    format(query: string): string;
    private formatAst;
    private postFormat;
}
